#ifndef COLORS_H
#define COLORS_H
#include "settings.h"
//get gui color
u32 GetColor(int component);
static const int DOWNLOAD_BACKGROUND=0; // Originaly Red
static const int DOWNLOAD_TEXTBOX_BACKGROUND=1; //Originaly White
static const int DOWNLOAD_FOREGROUND_NO_SELECTOR=2; // Originaly White
static const int DOWNLOAD_FOREGROUND_SELECTOR=3; // Originaly Blue
static const int DOWNLOAD_KEYBOARD_UNSELECT=4; // Originaly Blue
static const int DOWNLOAD_KEYBOARD_SELECT=5; // Originaly Yellow
static const int DOWNLOAD_TEXTBOX_FOREGROUND=6; // Originaly Black
static const int DOWNLOAD_CURSOR = 7; // Originaly Violet
static const int DOWNLOAD_PROGRESSBAR_FOREGROUND=8; //Originaly Violet
static const int DOWNLOAD_PROGRESSBAR_BACKGROUND=9; //Originaly White
static const int DOWNLOAD_PROGRESSVAL=10; //Originaly Blue
static const int DOWNLOAD_SELECTOR=11; //Originaly Green
static const int DOWNLOAD_KEYBOARD_OUTLINE=12; //Originaly Violet
#define TOTALCOLORS 13
//set gui color
void SetColor(u32 color,int component);
//set scheme
void InitColor(int scheme);
//cycle through color schemes
int AddScheme(int val);
#endif
